<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>Dependency upgrades | Eclipse ESCET™ development documentation</title>
  <link rel="stylesheet" href="../assets/asciidoctor-escet-dev.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../assets/asciidoctor-escet-dev.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="../..">Eclipse ESCET™ website</a></p>
    <div id="toctitle">
     Eclipse ESCET™ development documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../index.html">Home</a></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#eclipse-escet-development">Eclipse ESCET development</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="dev-list.html">The Eclipse ESCET dev-list</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="development-process.html">Development process</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#issue-tracking">Issue tracking</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#releases-and-milestones">Releases and milestones</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#working-on-issues">Working on issues</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#working-with-branches">Working with branches</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#commits">Commits</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#merge-requests">Merge requests</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="development-process.html#collaborating-with-contributors-on-a-merge-request">Collaborating with contributors on a merge request</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="development-process.html#simple-approach">Simple approach</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="development-process.html#advanced-approach">Advanced approach</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="development-process.html#fork-collaboration-script-support">Fork collaboration script support</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="contributing.html">Contributing</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="contributing.html#how-to-contribute-to-eclipse-escet">How to contribute to Eclipse ESCET</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="contributing.html#keeping-in-sync-with-the-official-eclipse-escet-gitlab-repository">Keeping in sync with the official Eclipse ESCET GitLab repository</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="contributing.html#how-to-become-a-committer">How to become a committer</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="issue-tracking.html">Issue tracking</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="dev-env-setup.html">Development environment setup</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="git-repo.html">Git repositories</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="git-repo.html#repository-structure">Repository structure</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="git-repo.html#language-directories">Language directories</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="git-repo.html#middle-layer-common-functionality">Middle layer common functionality</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="coding-standards.html">Coding standards</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="building-and-testing.html">Building and testing</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="release-process.html">Release process</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="release-process.html#release-policy">Release policy</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="release-process.html#release-retention-policy">Release retention policy</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="release-process.html#planning-for-a-next-version">Planning for a next version</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="release-process.html#preparing-git-repository-for-a-next-version">Preparing Git repository for a next version</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="release-process.html#working-on-a-release">Working on a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="release-process.html#preparing-a-release">Preparing a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="release-process.html#preparing-a-progress-review">Preparing a progress review</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="release-process.html#performing-a-release">Performing a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="release-process.html#removing-archiving-old-releases">Removing/archiving old releases</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="third-party-tools.html">Third party tools</a></li>
       <li class="toc-cur-page toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Dependency upgrades</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#eclipse-platform-ide-upgrades">Eclipse Platform/IDE upgrades</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#tycho-upgrades">Tycho upgrades</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#java-upgrades">Java upgrades</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="license-year-update.html">License year update</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/index.html">Application framework</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/introduction.html">Introduction</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/standalone-vs-eclipse.html">Stand-alone execution versus Eclipse IDE</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-static-information">Application static information</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-options">Application options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#stdin-stdout-and-stderr">Stdin, stdout, and stderr</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#graphical-user-interfaces-guis-and-swt">Graphical User Interfaces (GUIs) and SWT</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-termination">Application termination</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#sigint">SIGINT</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#exceptions">Exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#system-properties">System properties</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#file-paths-and-current-working-directory">File paths and current working directory</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/application-class.html">The Application class</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/exception-framework.html">The exception framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#end-user-exceptions">End-user exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#internal-exceptions">Internal exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#chained-exceptions">Chained exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#development-mode">Development mode</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/exit-codes.html">Exit codes</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/io-framework.html">The I/O framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#output-components">Output components</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#output-provider">Output provider</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#stdout-and-stderr">Stdout and stderr</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#stdin">Stdin</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#buffering-and-flushing">Buffering and flushing</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/option-framework.html">The option framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#the-option-class">The option class</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#command-line-options-and-the-option-dialog">Command line options and the option dialog</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#option-categories">Option categories</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#instantiating-options">Instantiating options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#getting-and-setting-option-values">Getting and setting option values</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#option-processing-order">Option processing order</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#command-line-option-syntax">Command line option syntax</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#implementing-your-own-options">Implementing your own options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#standard-options">Standard options</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/compiler-framework.html">The compiler framework</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/implement-your-application.html">How to implement your own application</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/implement-your-application.html#the-runinternal-method">The runInternal method</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/registration.html">Application registration</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#multi-threaded-applications">Multi-threaded applications</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#unit-tests">Unit tests</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#running-an-application-from-another-application">Running an application from another application</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/execution.html">Execution</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../dsm/index.html">Design Structure Matrix (DSM) library</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/entrypoint.html">Code organization</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/algorithm.html">Algorithm and code</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/busdetection.html">Bus detection algorithms</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/references.html">References</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../multivalue/index.html">Multi-value Decision Diagrams library</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/goals.html">Goals</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/variables-and-relations.html">Variables and relations</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/combining-relations.html">Combining relations</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/computing.html">Computing</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../multivalue/practical-usage.html">Practical usage</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../multivalue/practical-usage.html#variables">Variables</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../multivalue/practical-usage.html#trees-and-relations">Trees and relations</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/index.html">Rail diagram generator</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../rail/introduction.html">Introduction</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/examples.html">Examples</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#diagrams-and-sequences">Diagrams and sequences</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#choices">Choices</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#optional">Optional</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#repetition">Repetition</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#splitting-long-sequences">Splitting long sequences</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#referencing-a-path-in-the-diagram">Referencing a path in the diagram</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#terminals">Terminals</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#meta-terminals">Meta-terminals</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#further-reading">Further reading</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/customizing-output.html">Customizing output</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#syntax-of-the-properties-file">Syntax of the properties file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#kinds-of-values">Kinds of values</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#global-settings">Global settings</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#diagram-settings">Diagram settings</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#empty-node">Empty node</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#branch-label">Branch label</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/customizing-output.html#name-node">Name node</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#terminal-text-and-box-properties">Terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#meta-terminal-text-and-box-properties">Meta-terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#non-terminal-text-and-box-properties">Non-terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#token-text-translations">Token text translations</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#sequence">Sequence</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#choice">Choice</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#repetition">Repetition</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/customizing-output.html#debugging-properties">Debugging properties</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#hierarchy">Hierarchy</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#constraint-solving">Constraint solving</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#coordinates">Coordinates</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#default-property-values">Default property values</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../rail/commandline.html">Command-line arguments</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/lexical-syntax.html">Lexical syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/lexical-syntax.html#whitespace">Whitespace</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/lexical-syntax.html#comments">Comments</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/lexical-syntax.html#terminals">Terminals</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../rail/grammar.html">Grammar</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/debugging.html">Debugging</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/debugging.html#global-internal-structure-of-the-generator">Global internal structure of the generator</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/debugging.html#analyzing-output">Analyzing output</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../setext/index.html">SeText scanner/parser generator</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/lexical-syntax.html">SeText lexical syntax</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/specifying-lexical-syntax.html">Specifying lexical syntax using SeText</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/regular-expressions.html">Regular expressions</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/terminal-descriptions.html">Terminal descriptions</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/imports.html">Imports</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/scanner-hooks.html">Scanner hooks</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/specifying-grammars.html">Specifying grammars using SeText</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/parser-hooks.html">Parser hooks</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/usage-hints.html">Usage hints</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/generated-scanners-parsers.html">Generated scanners/parsers</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/using-in-an-eclipse-plugin-project.html">Using SeText in an Eclipse Plug-in Project</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/limitations.html">Limitations</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../index.html">Eclipse ESCET™ development documentation</a> &gt; <a class="breadcrumb" href="../index.html#eclipse-escet-development">Eclipse ESCET development</a> &gt; <span class="breadcrumb">Dependency upgrades</span>
   </div>
   <h2 id="dependency-upgrades"><a class="anchor" href="#"></a>Dependency upgrades</h2>
   <div class="paragraph">
    <p>The Eclipse ESCET toolset has various dependencies. From time to time, these dependencies need to be upgraded. This page discusses for some of the major dependencies <em>when</em> to upgrade and <em>how</em> to upgrade:</p>
   </div>
   <div class="ulist">
    <ul>
     <li>
      <p><a href="#eclipse-platform-ide-upgrades">Eclipse Platform/IDE upgrades</a></p></li>
     <li>
      <p><a href="#tycho-upgrades">Tycho upgrades</a></p></li>
     <li>
      <p><a href="#java-upgrades">Java upgrades</a></p></li>
    </ul>
   </div>
   <div class="sect3">
    <h3 id="eclipse-platform-ide-upgrades"><a class="anchor" href="#eclipse-platform-ide-upgrades"></a>Eclipse Platform/IDE upgrades</h3>
    <div class="paragraph">
     <p>The Eclipse ESCET IDE is based on the Eclipse IDE, which in turn is based on the Eclipse Platform. The Eclipse IDE is also used as the development environment of choice for Eclipse ESCET development.</p>
    </div>
    <div class="paragraph">
     <p>The Eclipse ESCET upgrade policy for the Eclipse Platform/IDE is:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Considering the overhead, only upgrade if there is a use for it. For instance, if we need a bug fix, some new feature, or so.</p></li>
      <li>
       <p>Upgrade to a new Eclipse version at least once a year, to stay current.</p></li>
      <li>
       <p>Consider the interplay between Eclipse and Java versions. Upgrading Eclipse may require upgrading Java if the new Eclipse version has a higher minimum Java version requirement. <a href="#java-upgrades">Upgrading Java</a> may require upgrading Eclipse to a newer version that supports that Java version.</p></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>To upgrade to a new Eclipse Platform/IDE version:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Check out the information for the new version:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Check the <a href="https://github.com/eclipse-simrel/.github/blob/main/wiki/Simultaneous_Release.md">Simultaneous Release</a> overview page for the link between platform version (e.g. <em>4.20</em>) and release name (e.g. <em>2021-06</em>).</p></li>
         <li>
          <p>Check <code><a href="https://www.eclipse.org/projects/project-plan.php?planurl=https://www.eclipse.org/eclipse/development/plans/eclipse_project_plan_N_NN.xml" class="bare">https://www.eclipse.org/projects/project-plan.php?planurl=https://www.eclipse.org/eclipse/development/plans/eclipse_project_plan_N_NN.xml</a></code> with <code>N_NN</code> replaced by the platform version (e.g. <code>4_20</code>), for the project plan of the release, including detailed information about the supported target environments (operating systems, Java versions, etc).</p></li>
         <li>
          <p>Check <code><a href="https://www.eclipse.org/eclipse/development/readme_eclipse_N.NN.php" class="bare">https://www.eclipse.org/eclipse/development/readme_eclipse_N.NN.php</a></code> with <code>N.NN</code> replaced by the platform version (e.g. <code>4.20</code>), for the README of the release.</p></li>
         <li>
          <p>Check the <a href="https://eclipseide.org/release/noteworthy/">New &amp; Noteworthy</a> page for the new release and all intermediate releases since the previous version. Note that you can switch to the New &amp; Noteworthy pages of previous releases using the dropdown at the bottom of the page.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Upgrade the development environment</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Alternative 1: set up a fresh new development environment.</p>
          <div class="ulist">
           <ul>
            <li>
             <p>The benefit of this alternative is that you get a clean new environment, and can use it side-by-side with existing development environments. The downside is that you have to manually configure the new environment, or manually migrate your workspace and settings. You also have to cleanup or remove your old development environments, in case you don’t use them anymore.</p></li>
            <li>
             <p><a href="dev-env-setup.html">Set up a new development environment</a> for the new Eclipse IDE version.</p></li>
           </ul>
          </div></li>
         <li>
          <p>Alternative 2: in-place upgrade of an existing development environment.</p>
          <div class="ulist">
           <ul>
            <li>
             <p>The benefit of this alternative is that you can keep your existing environment, preventing multiple such environments as well as manual migrations. The downside is that you run the risk of older things remaining in your development environment, requiring manual cleanup.</p></li>
            <li>
             <p>Update the <em>P2 Director</em> section of the Oomph setup (<code>org.eclipse.escet.setup</code>), if needed. Especially, consider what is no longer compatible with the new Eclipse version and remove it, or replace it by an alternative.</p></li>
            <li>
             <p>If you removed anything from the <em>P2 Director</em> section of the Oomph setup, also remove it manually from your development environment:</p>
             <div class="ulist">
              <ul>
               <li>
                <p>Click <span class="menuseq"><b class="menu">Help</b>&nbsp;<i class="fa fa-angle-right caret"></i> <b class="menuitem">About Eclipse Platform</b></span>.</p></li>
               <li>
                <p>Click the <b class="button">Installation Details</b> button.</p></li>
               <li>
                <p>Select on the <em>Installed Software</em> tab the item to remove and click the <b class="button">Uninstall…​</b> button.</p></li>
               <li>
                <p>On the <em>Uninstall</em> dialog, click the <b class="button">Finish</b> button.</p></li>
               <li>
                <p>When asked to restart the Eclipse Platform, click <b class="button">Restart Now</b> (newer Eclipse versions) or <b class="button">Yes</b> (older Eclipse versions).</p></li>
               <li>
                <p>Repeat these steps for each item that was removed from the <em>P2 Director</em> section of the Oomph setup.</p></li>
              </ul>
             </div></li>
            <li>
             <p>Update your installation profile for the new Eclipse version, and apply it:</p>
             <div class="ulist">
              <ul>
               <li>
                <p>From the toolbar, select the dropdown menu of the <b class="menuref">Open User</b> item and choose <b class="menuref">Open Installation</b>.</p></li>
               <li>
                <p>Select the <em>Installation file:…​</em> node.</p></li>
               <li>
                <p>In the <em>Properties</em> view, change the <em>Product Version</em> to the <em>Eclipse Platform</em> edition of the new Eclipse version.</p></li>
               <li>
                <p>Save the <code>installation.setup</code> file.</p></li>
               <li>
                <p>Click <span class="menuseq"><b class="menu">File</b>&nbsp;<i class="fa fa-angle-right caret"></i> <b class="menuitem">Restart</b></span>.</p></li>
               <li>
                <p>Once Eclipse restarts, you should see some initialization progress at the bottom right corner of the development environment window.</p></li>
               <li>
                <p>Wait for the <em>Eclipse Update</em> dialog to appear, indicating that <em>The installation does not satisfy the requirements list below</em>.</p></li>
               <li>
                <p>Click the <b class="button">Install</b> button to update Eclipse.</p></li>
               <li>
                <p>Wait for the update to complete, while observing the progress at the bottom right corner of the development environment window.</p></li>
               <li>
                <p>If a <em>Trust</em> dialog appears, click <b class="button">Select All</b> and then <b class="button">Trust Selected</b>.</p></li>
               <li>
                <p>After some time, notice the Oomph icon with the flashing warning sign (<span class="image"><img src="oomph-icon-warning.png" alt="oomph icon warning"></span>) at the bottom right corner of the development environment window.</p></li>
               <li>
                <p>Click it to open the <em>Eclipse Updater</em> window.</p></li>
               <li>
                <p>Click <b class="button">Finish</b> to restart Eclipse, completing the update.</p></li>
               <li>
                <p>Once Eclipse restarts, you may see a <em>Older Workspace Version</em> popup.</p></li>
               <li>
                <p>If so, click <b class="button">Continue</b> to update your workspace to the new Eclipse version.</p></li>
              </ul>
             </div></li>
           </ul>
          </div></li>
        </ul>
       </div></li>
      <li>
       <p>Version updates</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Update the target platform (<code>org.eclipse.escet.releng.target/org.eclipse.escet.releng.target.target</code>), configuring new versions for the Eclipse IDE and Orbit update sites.</p></li>
         <li>
          <p>Update <code>dev-env-setup.asciidoc</code> to match the new Eclipse version.</p></li>
         <li>
          <p>Update <code>org.eclipse.platform</code> version for the product feature (<code>org.eclipse.escet.product.feature/feature.xml</code>).</p></li>
         <li>
          <p>Update Eclipse and Orbit update site URLs in the product (<code>org.eclipse.escet.product/escet.product</code>).</p></li>
         <li>
          <p>Update Maven plugin third party dependency versions to match the versions of these plugins from the target platform (<code>org.eclipse.escet.common.asciidoc/pom.xml</code>).</p></li>
         <li>
          <p>Commit any changes.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Update target platform and adapt to the new Eclipse version</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Let Oomph reactivate the target platform, and address any issues.</p></li>
         <li>
          <p>Commit any changes.</p></li>
         <li>
          <p>Force a rebuild in Eclipse (<span class="menuseq"><b class="menu">Project</b>&nbsp;<i class="fa fa-angle-right caret"></i> <b class="menuitem">Clean…​</b></span>).</p></li>
         <li>
          <p>Check the workspace for any errors/warnings and address them if any.</p></li>
         <li>
          <p>Commit any changes.</p></li>
         <li>
          <p>Check <em>New and Noteworthy</em> (release notes) of the new Eclipse version and relevant intermediate versions for changes and adapt as necessary.</p></li>
         <li>
          <p>Commit any changes.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Java formatter profile</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Right click the <code>org.eclipse.escet.common.java</code> project in the <em>Package Explorer</em> view and choose <b class="menuref">Properties</b>.</p></li>
         <li>
          <p>In the properties dialog, select <span class="menuseq"><b class="menu">Java Code Style</b>&nbsp;<i class="fa fa-angle-right caret"></i> <b class="menuitem">Formatter</b></span>.</p></li>
         <li>
          <p>Make sure the <em>Unmanaged profile</em> is selected and click <b class="button">Edit…​</b>.</p></li>
         <li>
          <p>Change the <em>Profile name</em> to <code>tmp</code>.</p></li>
         <li>
          <p>Click <b class="button">OK</b> to close the profile editing dialog, and then clicking <b class="button">Apply and Close</b> to close the properties dialog.</p></li>
         <li>
          <p>Remove the <em>tmp</em> profile:</p>
          <div class="ulist">
           <ul>
            <li>
             <p>Remove the <code>formatter_profile=_tmp</code> line from the <code>.settings/org.eclipse.jdt.ui.prefs</code> file in the project.</p></li>
            <li>
             <p>Navigate to <span class="menuseq"><b class="menu">Window</b>&nbsp;<i class="fa fa-angle-right caret"></i> <b class="menuitem">Preferences</b></span>.</p></li>
            <li>
             <p>In the dialog, navigate to <span class="menuseq"><b class="menu">Java</b>&nbsp;<i class="fa fa-angle-right caret"></i> <b class="submenu">Code Style</b>&nbsp;<i class="fa fa-angle-right caret"></i> <b class="menuitem">Formatter</b></span>.</p></li>
            <li>
             <p>Select the <em>tmp</em> profile.</p></li>
            <li>
             <p>Click the <b class="button">Remove</b> button and confirm the removal by clicking <b class="button">Yes</b>.</p></li>
            <li>
             <p>Close the preference dialog by clicking <b class="button">Apply and Close</b>.</p></li>
            <li>
             <p>If an Oomph preference recorder dialog appears, dismiss it by clicking <b class="button">Cancel</b>.</p></li>
           </ul>
          </div></li>
         <li>
          <p>If in the <code>org.eclipse.escet.common.java</code> project, in the <code>.settings</code> directory, there are changes to any of the <code>*.prefs</code> files:</p>
          <div class="ulist">
           <ul>
            <li>
             <p>Run <code>./copy_here.bash ../../common/org.eclipse.escet.common.java</code> from <code>misc/java-code-style</code> to copy the new preferences to the central place.</p></li>
            <li>
             <p>Run <code>./copy_there.bash</code> from <code>misc/java-code-style</code> to copy the new preferences to all relevant projects.</p></li>
            <li>
             <p>Refresh all projects, and wait until the rebuild completes.</p></li>
            <li>
             <p>Commit the preference changes.</p></li>
            <li>
             <p>Reformat all projects.</p></li>
            <li>
             <p>Commit any code changes.</p></li>
           </ul>
          </div></li>
         <li>
          <p>In case of new formatter preferences, configure them as desired. Apply each preference change separately, to allow easier reviewing:</p>
          <div class="ulist">
           <ul>
            <li>
             <p>Change a single formatter preference on the <code>org.eclipse.escet.common.java</code> project. This requires giving the unmanaged profile the name <em>tmp</em> again, as before.</p></li>
            <li>
             <p>Remove the <em>tmp</em> profile, as before.</p></li>
            <li>
             <p>Run <code>./copy_here.bash ../../common/org.eclipse.escet.common.java</code> from <code>misc/java-code-style</code> to copy the changed formatter preference to the central place.</p></li>
            <li>
             <p>Run <code>./copy_there.bash</code> from <code>misc/java-code-style</code> to copy the changed formatter preference to all relevant projects.</p></li>
            <li>
             <p>Refresh all projects, and wait until the rebuild completes.</p></li>
            <li>
             <p>Commit the preference changes.</p></li>
            <li>
             <p>Reformat all projects.</p></li>
            <li>
             <p>Commit reformatting changes.</p></li>
           </ul>
          </div></li>
         <li>
          <p>If any changes were made to the formatter preferences, manually update the <code>org.eclipse.escet.*.metamodel</code> projects to have the same formatter settings as the rest of the projects.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Java errors/warnings settings</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Right click the <code>org.eclipse.escet.common.java</code> project in the <em>Package Explorer</em> view and choose <b class="menuref">Properties</b>.</p></li>
         <li>
          <p>In the properties dialog, select <span class="menuseq"><b class="menu">Java Compiler</b>&nbsp;<i class="fa fa-angle-right caret"></i> <b class="menuitem">Errors/Warnings</b></span>.</p></li>
         <li>
          <p>Make a dummy change and apply it by clicking <b class="button">Apply and Close</b>.</p></li>
         <li>
          <p>Click <b class="button">Yes</b> when asked to <em>Rebuild the project now to apply the changes of the Error/Warning settings?</em>.</p></li>
         <li>
          <p>Revert the dummy change, using again the same steps.</p></li>
         <li>
          <p>In case of changes to <code>*.prefs</code> files in the <code>.settings</code> directory of that project, configure the new preferences as desired.</p></li>
         <li>
          <p>Run <code>./copy_here.bash ../../common/org.eclipse.escet.common.java</code> from <code>misc/java-code-style</code> to copy the new preferences to the central place.</p></li>
         <li>
          <p>Run <code>./copy_there.bash</code> from <code>misc/java-code-style</code> to copy the new preferences to all relevant projects.</p></li>
         <li>
          <p>Manually update the <code>org.eclipse.escet.*.metamodel</code> projects to have similar error/warnings settings as the rest of the projects (be aware, some settings are configured differently).</p></li>
         <li>
          <p>Force a rebuild in Eclipse (<span class="menuseq"><b class="menu">Project</b>&nbsp;<i class="fa fa-angle-right caret"></i> <b class="menuitem">Clean…​</b></span>) and check for any warnings/errors, addressing them if any.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Eclipse application launch configurations</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Select each Eclipse application launch configuration in the <em>Run Configurations</em> dialog, then select the next one, and so on. In the <em>Run Configurations</em> dialog, these launch configurations are under the <em>Eclipse Applications</em> category.</p></li>
         <li>
          <p>Run each Eclipse application launch configuration, from the <em>Run Configurations</em> dialog. Make sure they work as expected.</p></li>
         <li>
          <p>If Eclipse makes any changes to the corresponding <code>*.launch</code> files for these launch configurations, commit the changes.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Update Maven version</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Check the embedded Maven version, by navigating to <span class="menuseq"><b class="menu">Run</b>&nbsp;<i class="fa fa-angle-right caret"></i> <b class="menuitem">Run Configurations…​</b></span>, selecting the <em>build</em> launch configuration under <em>Maven Build</em>, and observing the <em>Maven Runtime</em> version.</p></li>
         <li>
          <p>Ensure the Maven version in <code>Jenkinsfile</code> matches the embedded Maven version.</p></li>
         <li>
          <p>Ensure the Maven version in <code>misc/license-check-dependencies/Jenkinsfile</code> matches the embedded Maven version.</p></li>
         <li>
          <p>Update version of the <code>maven-plugin-api</code> to match new Maven version (<code>org.eclipse.escet.common.asciidoc/pom.xml</code>).</p></li>
         <li>
          <p>Update version of the <code>maven-plugin-annotations</code> if needed (<code>org.eclipse.escet.common.asciidoc/pom.xml</code>).</p></li>
         <li>
          <p>Update version of the <code>maven-plugin-plugin</code> if needed (<code>org.eclipse.escet.releng.configuration/pom.xml</code>).</p></li>
        </ul>
       </div></li>
      <li>
       <p>Validation</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Run a <a href="building-and-testing.html">Maven build</a>.</p></li>
         <li>
          <p>Ensure no errors or warnings during Maven build.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Dependency information</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Run <code>misc/license-check-dependencies/license-check-dependencies.sh</code> and update <code>DEPENDENCIES.txt</code> according to the output.</p></li>
         <li>
          <p>Run <code>misc/license-check-dependencies/license-check-dependencies.sh</code> again, to ensure <code>DEPENDENCIES.txt</code> is up-to-date.</p></li>
        </ul>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="tycho-upgrades"><a class="anchor" href="#tycho-upgrades"></a>Tycho upgrades</h3>
    <div class="paragraph">
     <p>Eclipse Tycho is used for the Eclipse ESCET build.</p>
    </div>
    <div class="paragraph">
     <p>The Eclipse ESCET upgrade policy for Tycho is:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Typically upgrading to a newer version can be done at any time, if it is considered relevant.</p></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>To upgrade to a new Tycho version:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Update <code>version</code> in <code>org.eclipse.escet.root/.mvn/extensions.xml</code>.</p></li>
      <li>
       <p>Update <code>tycho.version</code> in <code>org.eclipse.escet.releng.configuration/pom.xml</code>.</p></li>
      <li>
       <p>Update <code>maven.minimal.version</code> in <code>org.eclipse.escet.releng.configuration/pom.xml</code>, if the new Tycho version requires a higher Maven version.</p></li>
      <li>
       <p>Check Tycho release notes for changes and adapt as necessary.</p></li>
      <li>
       <p>Run a <a href="building-and-testing.html">Maven build</a>.</p></li>
      <li>
       <p>Perform a license check (<code>misc/license-check-dependencies/license-check-dependencies.sh</code>).</p></li>
      <li>
       <p>Ensure no errors or warnings during Maven build.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="java-upgrades"><a class="anchor" href="#java-upgrades"></a>Java upgrades</h3>
    <div class="paragraph">
     <p>Most of the Eclipse ESCET source code is written in Java.</p>
    </div>
    <div class="paragraph">
     <p>The Eclipse ESCET upgrade policy for Java is:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Considering the overhead, only upgrade if there is a use for it. For instance, if we need a bug fix, some new feature, or so.</p></li>
      <li>
       <p>Upgrade when a Java version we use is no longer actively supported.</p></li>
      <li>
       <p>Only upgrade to a Java LTS release.</p></li>
      <li>
       <p>Don’t upgrade to newer Java versions immediately, but only after (industrial) adoption is high enough. As a general guideline, if at least 50% of developers, users and enterprises use the new LTS version, consider upgrading. Java usage is regularly surveyed, and reports can typically be found online. For instance, the <a href="https://outreach.jakartaee.org/2021-developer-survey-report">2021 Jakarta EE Developer Survey Report</a> of the Eclipse Jakarta EE project indicates that in 2021 about 58% of the developers and 11% of the enterprises used Java 11.</p></li>
      <li>
       <p>Consider the interplay between Java and Eclipse versions. Upgrading Java may require upgrading Eclipse to a newer version that supports that Java version. <a href="#eclipse-platform-ide-upgrades">Upgrading Eclipse</a> may require upgrading Java if the new Eclipse version has a higher minimum Java version requirement.</p></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>To upgrade to a new Java version:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>For major Java versions (e.g. 17 to 18):</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Update all (plugin) projects:</p>
          <div class="ulist">
           <ul>
            <li>
             <p>Update <code>Bundle-RequiredExecutionEnvironment</code> for all plug-in manifests.</p></li>
            <li>
             <p>Update <code>JRE_CONTAINER</code> in all <code>.classpath</code> files.</p></li>
            <li>
             <p>Update <code>JRE_CONTAINER</code> in all launch configurations (<code>.launch</code> files).</p></li>
            <li>
             <p>Update Java versions in all <code>org.eclipse.jdt.core.prefs</code> files (<code>compiler.codegen.targetPlatform</code>, <code>compiler.compliance</code>, and <code>compiler.source</code>).</p></li>
           </ul>
          </div></li>
         <li>
          <p>Update all metamodel projects (<code>org.eclipse.escet.*.metamodel</code> projects):</p>
          <div class="ulist">
           <ul>
            <li>
             <p>Update the <code>autofix.py</code> scripts of these projects, by changing the compliance level resulting from replacements.</p></li>
            <li>
             <p>Change in all <code>*.genmodel</code> files the <code>complianceLevel</code>.</p></li>
            <li>
             <p>Regenerate the model code for each metamodel project, by opening the corresponding <code>.genmodel</code> file, right clicking the root node of the opened generator model, and choosing <b class="menuref">Generate Model Code</b>. There won’t always be changes.</p></li>
           </ul>
          </div></li>
         <li>
          <p>Update the product:</p>
          <div class="ulist">
           <ul>
            <li>
             <p>Update <code>osgi.requiredJavaVersion</code> in the product (<code>org.eclipse.escet.product/escet.product</code>).</p></li>
            <li>
             <p>Update <code>osgi.requiredJavaVersion</code> in the product launch configuration (<code>org.eclipse.escet.product/*.launch</code>).</p></li>
           </ul>
          </div></li>
         <li>
          <p>Update the build:</p>
          <div class="ulist">
           <ul>
            <li>
             <p>Update Java version for <code>escet.java.version</code> in <code>org.eclipse.escet.releng.configuration/pom.xml</code>.</p></li>
            <li>
             <p>Update Java version for <code>executionEnvironment</code> in <code>org.eclipse.escet.releng.configuration/pom.xml</code>.</p></li>
            <li>
             <p>Update Java version in <code>Jenkinsfile</code>.</p></li>
            <li>
             <p>Update Java version in <code>misc/license-check-dependencies/Jenkinsfile</code>.</p></li>
           </ul>
          </div></li>
         <li>
          <p>Update all Java code and documentation:</p>
          <div class="ulist">
           <ul>
            <li>
             <p>Update Java keywords for <code>org.eclipse.escet.common.java.JavaCodeUtils.JAVA_IDS</code>. Update the keywords themselves and the field’s JavaDoc, including the link to the Java Language Specification (JLS).</p></li>
            <li>
             <p>Update <code>dev-env-setup.asciidoc</code> to match new Java version.</p></li>
            <li>
             <p>Update links to specific versions of the Java documentation (search for <code>https://docs.oracle.com</code>).</p></li>
           </ul>
          </div></li>
         <li>
          <p>Search for the current Java version to find other references (e.g., search for <code>17</code>).</p></li>
        </ul>
       </div></li>
      <li>
       <p>For any Java versions (e.g. 17 to 18, or 17.0.1 to 17.0.2):</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Update the JustJ update site URL in the target platform (<code>org.eclipse.escet.releng.target/org.eclipse.escet.releng.target.target</code>).</p></li>
         <li>
          <p>Re-activate the target platform using Oomph.</p></li>
         <li>
          <p>Update JustJ version for the product feature (<code>org.eclipse.escet.product.feature/feature.xml</code>).</p></li>
         <li>
          <p>Force a rebuild in Eclipse (<span class="menuseq"><b class="menu">Project</b>&nbsp;<i class="fa fa-angle-right caret"></i> <b class="menuitem">Clean…​</b></span>) and check for any warnings/errors, addressing them if any.</p></li>
         <li>
          <p>Run a <a href="building-and-testing.html">Maven build</a>.</p></li>
         <li>
          <p>Ensure no errors or warnings during Maven build.</p></li>
         <li>
          <p>Run <code>misc/license-check-dependencies/license-check-dependencies.sh</code> and update <code>DEPENDENCIES.txt</code> according to the output.</p></li>
         <li>
          <p>Run <code>misc/license-check-dependencies/license-check-dependencies.sh</code> to ensure <code>DEPENDENCIES.txt</code> is up-to-date.</p></li>
        </ul>
       </div></li>
     </ul>
    </div>
   </div>
  </div>
  <script src="../assets/highlight.min.js"></script>
  <script src="../assets/languages/asciidoc.min.js"></script>
  <script src="../assets/languages/bash.min.js"></script>
  <script src="../assets/languages/bnf.min.js"></script>
  <script src="../assets/languages/c.min.js"></script>
  <script src="../assets/languages/chi.min.js"></script>
  <script src="../assets/languages/cif.min.js"></script>
  <script src="../assets/languages/console.min.js"></script>
  <script src="../assets/languages/css.min.js"></script>
  <script src="../assets/languages/dsm.min.js"></script>
  <script src="../assets/languages/java.min.js"></script>
  <script src="../assets/languages/javascript.min.js"></script>
  <script src="../assets/languages/markdown.min.js"></script>
  <script src="../assets/languages/mcrl2.min.js"></script>
  <script src="../assets/languages/none.min.js"></script>
  <script src="../assets/languages/plcst.min.js"></script>
  <script src="../assets/languages/properties.min.js"></script>
  <script src="../assets/languages/raildiagram.min.js"></script>
  <script src="../assets/languages/setext.min.js"></script>
  <script src="../assets/languages/shell.min.js"></script>
  <script src="../assets/languages/tooldef.min.js"></script>
  <script src="../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Eclipse ESCET™ development documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v6.0-RC1</span>
    <br><a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>